import * as screenfull from "screenfull";
import { Screenfull } from "screenfull"; // @see https://github.com/sindresorhus/screenfull.js/issues/126#issuecomment-488796645

/**
 * Base class for results components, including common features
 */
export class ResultsComponent {

    /** tracks the fullscreen state */
    public get isFullscreen() {
        // return (document["fullscreenElement"] !== null);
        const sf = <Screenfull>screenfull;
        if (sf.enabled) {
            return sf.isFullscreen;
        }
    }

    public setFullscreen(element) {
        // element.requestFullscreen();
        const sf = <Screenfull>screenfull;
        if (sf.enabled) {
            sf.request(element);
        }
    }

    public exitFullscreen() {
        // document.exitFullscreen();
        const sf = <Screenfull>screenfull;
        if (sf.enabled) {
            sf.exit();
        }
    }

    /**
     * 14 distinct colors @see https://sashat.me/2017/01/11/list-of-20-simple-distinct-colors
     */
    public static get distinctColors(): string[] {
        return [
            "#4363d8", // blue
            "#f58231", // orange
            "#3cb44b", // green
            "#e6194B", // red
            "#911eb4", // purple
            "#ffe119", // yellow
            "#f032e6", // magenta
            "#9A6324", // brown
            "#000075", // navy
            "#808000", // olive
            "#42d4f4", // cyan
            "#a9a9a9", // grey
            "#bfef45", // lime
            "#469990", // teal
        ];
    }
}
